#include <iostream>
#include <string>
#include <time.h> 
#include <math.h>
#include <set>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <vector>
#include <sstream>
#include <iterator>

#define NLINE   10000000
#define NCOLUMN 23

using namespace std;

class Line
{
    private:
    double 	L[NCOLUMN];
    
    public:
    Line(void){for(int i=0;i<NCOLUMN;i++) {L[i]=0;}}
    ~Line(void){}
    
    inline double& operator[](int i){return L[i];}
};

bool Compare (Line l1, Line l2) 
{
     if (l1[2]==l2[2]) 
        if ((l1[3]+l1[4])==(l2[3]+l2[4]))
           if (l1[6]==l2[6])
              if (l1[5]==l2[5])
                 return(l1[1]<l2[1]);
              else return(l1[5]<l2[5]);
           else return(l1[6]<l2[6]);
        else return ((l1[3]+l1[4])<(l2[3]+l2[4])); 
     else return(l1[2]<l2[2]);
}

int chordcollection(int noct, int cs, int bass, int iprogression)
{
    vector<Line> array;
    vector<Line>::iterator it;
    Line row;
    int c, hn1, hn2, oct, oct1, oct2, ic13;
    long long chord, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, l, time;
    double m2, pcs012, pcs014, pcs016, pcs036;    
    int a[13], oa[13];
    double** coll=new double*[23];
    for (int i=0; i<23; i++)
        coll[i]=new double[10000000];
    double hw[17];
    set<int> aset;
    set<int>::iterator ait; 
    set<int> bset;
    set<int>::iterator bit;
    
    std::string textfilename ("collection");
    string chordnumber;
    ostringstream convert;
    convert << iprogression;
    chordnumber = convert.str();
    textfilename += chordnumber;
    textfilename += ".txt";

    // Setting the initial values of some of the parameters
    c=0;    
    hn1=0;
    hn2=0;
    oct1=0;
    oct2=0;
    m2=0;
    pcs012=0;
    pcs014=0;
    pcs016=0;
    pcs036=0;
    ic13=0;
    
    // Setting the harmonic weights
    hw[0]=0;
    hw[1]=1;
    hw[2]=0.5;
    hw[3]=0.3333;
    hw[4]=0.25;
    hw[5]=0.2;
    hw[6]=0.1666;
    hw[7]=0.1428;
    hw[8]=0.125;
    hw[9]=0.1111;
    hw[10]=0.1;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
    
    noct=noct-1; 
    cs=cs-1;
    
    // Creating all the chords with the desired number of chord-tones and chord-span: (i1, i2, i3, i4, ..., i12) 
    i1=48;
    {
        for (i2=i1+1; i2<(49+cs+12-noct); i2++)                
        {            
            if ((noct<2) || ((i2%12!=i1%12) && (i2%12!=(cs+1+48)%12)))
            {                   
                for (i3=i2+1; i3<(49+cs+12-noct); i3++)                                        
                {
                    if ((noct<3) || ((i3%12!=i1%12) && (i3%12!=i2%12) && (i3%12!=(cs+1+48)%12)))
                    {
                        for (i4=i3+1; i4<(49+cs+12-noct); i4++)                                        
                        {
                            if ((noct<4) || ((i4%12!=i1%12) && (i4%12!=i2%12) && (i4%12!=i3%12) && (i4%12!=(cs+1+48)%12)))
                            {                                               
                                for (i5=i4+1; i5<(49+cs+12-noct); i5++)                                        
                                {
                                    if ((noct<5) || ((i5%12!=i1%12) && (i5%12!=i2%12) && (i5%12!=i3%12) && (i5%12!=i4%12) && (i5%12!=(cs+1+48)%12)))
                                    {                                                                                                                                            
                                        for (i6=i5+1; i6<(49+cs+12-noct); i6++)                                        
                                        {
                                            if ((noct<6) || ((i6%12!=i1%12) && (i6%12!=i2%12) && (i6%12!=i3%12) && (i6%12!=i4%12) && (i6%12!=i5%12) && (i6%12!=(cs+1+48)%12)))
                                            {                                                                                                                                                                                
                                                for (i7=i6+1; i7<(49+cs+12-noct); i7++)                                        
                                                {
                                                    if ((noct<7) || ((i7%12!=i1%12) && (i7%12!=i2%12) && (i7%12!=i3%12) && (i7%12!=i4%12) && (i7%12!=i5%12) && (i7%12!=i6%12) && (i7%12!=(cs+1+48)%12)))
                                                    {                                               
                                                        for (i8=i7+1; i8<(49+cs+12-noct); i8++)                                        
                                                        {
                                                            if ((noct<8) || ((i8%12!=i1%12) && (i8%12!=i2%12) && (i8%12!=i3%12) && (i8%12!=i4%12) && (i8%12!=i5%12) && (i8%12!=i6%12) && (i8%12!=i7%12) && (i8%12!=(cs+1+48)%12)))
                                                            {                                                                                                                                            
                                                                for (i9=i8+1; i9<(49+cs+12-noct); i9++)                                        
                                                                {
                                                                    if ((noct<9) || ((i9%12!=i1%12) && (i9%12!=i2%12) && (i9%12!=i3%12) && (i9%12!=i4%12) && (i9%12!=i5%12) && (i9%12!=i6%12) && (i9%12!=i7%12) && (i9%12!=i8%12) && (i9%12!=(cs+1+48)%12)))
                                                                    {                                                                                                                                                                                        
                                                                        for (i10=i9+1; i10<(49+cs+12-noct); i10++)                                        
                                                                        { 
                                                                            if ((noct<10) || ((i10%12!=i1%12) && (i10%12!=i2%12) && (i10%12!=i3%12) && (i10%12!=i4%12) && (i10%12!=i5%12) && (i10%12!=i6%12) && (i10%12!=i7%12) && (i10%12!=i8%12) && (i10%12!=i9%12) && (i10%12!=(cs+1+48)%12)))
                                                                            {           
                                                                                for (i11=i10+1; i11<(49+cs+12-noct); i11++)                                        
                                                                                {
                                                                                    if ((noct<11) || ((i11%12!=i1%12) && (i11%12!=i2%12) && (i11%12!=i3%12) && (i11%12!=i4%12) && (i11%12!=i5%12) && (i11%12!=i6%12) && (i11%12!=i7%12) && (i11%12!=i8%12) && (i11%12!=i9%12) && (i11%12!=i10%12) && (i11%12!=(cs+1+48)%12)))
                                                                                    {                                                                                                                                                                                        
                                                                                        for (i12=i11+1; i12<(49+cs+12-noct); i12++)                                        
                                                                                        {                                                                                  
                                                                                            if ((noct<12) || ((i12%12!=i1%12) && (i12%12!=i2%12) && (i12%12!=i3%12) && (i12%12!=i4%12) && (i12%12!=i5%12) && (i12%12!=i6%12) && (i12%12!=i7%12) && (i12%12!=i8%12) && (i12%12!=i9%12) && (i12%12!=i10%12) && (i12%12!=i11%12) && (i12%12!=(cs+1+48)%12)))
                                                                                            {                                                                                                    
                                                                                                noct++;
                                                                                                
                                                                                                c++;
                                                                                                                                                                                                                                                                                                
                                                                                                coll[11][c]=i1;
                                                                                                coll[12][c]=i2;
                                                                                                coll[13][c]=i3;
                                                                                                coll[14][c]=i4;
                                                                                                coll[15][c]=i5;
                                                                                                coll[16][c]=i6;
                                                                                                coll[17][c]=i7;
                                                                                                coll[18][c]=i8;
                                                                                                coll[19][c]=i9;
                                                                                                coll[20][c]=i10;
                                                                                                coll[21][c]=i11;
                                                                                                coll[22][c]=i12;
                                                                                                
                                                                                                coll[noct+10][c]=48+1+cs;                                                                                                                                                                                                          
                                                                                                                                                                          
                                                                                                oa[1]=i1;
                                                                                                oa[2]=i2;
                                                                                                oa[3]=i3;
                                                                                                oa[4]=i4;
                                                                                                oa[5]=i5;
                                                                                                oa[6]=i6;
                                                                                                oa[7]=i7;
                                                                                                oa[8]=i8;
                                                                                                oa[9]=i9;
                                                                                                oa[10]=i10;
                                                                                                oa[11]=i11;
                                                                                                oa[12]=i12;        
                                                                                                
                                                                                                oa[noct]=48+cs+1;                                                                                                                                                                                                          
                                                                                                                        
                                                                                                // Searching for tense trichords and evaluating their significance in the overall tension of each chord
                                                                                                // The effect of the presence of a tense trichord on the overall tension of a complex chord is more significant when the tones of the tense trichord are not too widely spread.                                                                                                
                                                                                                for (int i=1; i<(noct+1); i++)
                                                                                                    for (int j=i+1; j<(noct+1); j++)
                                                                                                        for (int k=j+1; k<(noct+1); k++)                 
                                                                                                        {
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==1)) pcs012=pcs012+1;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==10)) pcs012=pcs012+.75;
                                                                                                            if (((oa[j]-oa[i])==10) && ((oa[k]-oa[j])==1)) pcs012=pcs012+.75;                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==13)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==1)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==2) && ((oa[k]-oa[j])==11)) pcs012=pcs012+.37;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==22)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==10)) pcs012=pcs012+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==2)) pcs012=pcs012+.37;                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==22) && ((oa[k]-oa[j])==1)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==10) && ((oa[k]-oa[j])==13)) pcs012=pcs012+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==11)) pcs012=pcs012+.37;
                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==3)) pcs014=pcs014+1;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==1)) pcs014=pcs014+1;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==8)) pcs014=pcs014+.75;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==3)) pcs014=pcs014+.75;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==8)) pcs014=pcs014+1;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==1)) pcs014=pcs014+1;
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==15)) pcs014=pcs014+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==3)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==4) && ((oa[k]-oa[j])==9)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==13)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==4) && ((oa[k]-oa[j])==11)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==1)) pcs014=pcs014+.5;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==4)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==20)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==8)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==4)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==20)) pcs014=pcs014+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==8)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==9)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==15)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==20) && ((oa[k]-oa[j])==3)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==11)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==13)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==20) && ((oa[k]-oa[j])==1)) pcs014=pcs014+.5;
                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==5)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==1)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==6)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==1)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.75;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==5)) pcs016=pcs016+.75;
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==17)) pcs016=pcs016+.5;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==7)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==5)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==13)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==11)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==17) && ((oa[k]-oa[j])==1)) pcs016=pcs016+.5;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==18)) pcs016=pcs016+.5;
                                                                                                            if (((oa[j]-oa[i])==7) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37; 
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==18)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==17) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37;                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==17)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==7)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==18) && ((oa[k]-oa[j])==5)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==13)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==7) && ((oa[k]-oa[j])==11)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==18) && ((oa[k]-oa[j])==1)) pcs016=pcs016+.5;                                                                                                     
                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==3)) pcs036=pcs036+1;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==6)) pcs036=pcs036+.75;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==3)) pcs036=pcs036+.75;
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==15)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==9)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==3)) pcs036=pcs036+.5;   
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==20)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==6)) pcs036=pcs036+.5;   
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==6)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==15)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==9)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==18) && ((oa[k]-oa[j])==3)) pcs036=pcs036+.5;                                                                                                                                              
                                                                                                        }
                                                                                                                                                    
                                                                                                // Searching for minor ninths in the intervalic content of each chord
                                                                                                for (int i=1; i<(noct+1); i++)
                                                                                                    for (int j=i+1; j<(noct+1); j++)
                                                                                                    {
                                                                                                        if (oa[j]-oa[i]==13) ic13=ic13+1;
                                                                                                    }                                        
                                                                                                
                                                                                                // Creating a superset of all the harmonics series to search for minor seconds in the intervalic content of this superset
                                                                                                // Repeated tones will appear only once.
                                                                                                for (int i=1; i<(noct+1); i++)
                                                                                                {                            
                                                                                                    a[i]=oa[i]%12;                    
                                                                                                
                                                                                                    aset.insert(a[i]);
                                                                                                    aset.insert(a[i]+12);
                                                                                                    aset.insert(a[i]+19);
                                                                                                    aset.insert(a[i]+24);
                                                                                                    /*
                                                                                                    aset.insert(a[i]+28);                                
                                                                                                    aset.insert(a[i]+31);                                
                                                                                                    aset.insert(a[i]+34);
                                                                                                    aset.insert(a[i]+36);
                                                                                                    aset.insert(a[i]+38);
                                                                                                    aset.insert(a[i]+40);
                                                                                                    */                                                        
                                                                                                }
                                                                                                
                                                                                                
                                                                                                // Searching for minor seconds in the superset
                                                                                                for (ait=aset.begin(); ait!=aset.end(); ait++)
                                                                                                {
                                                                                                    bit=ait;
                                                                                                    bit++;
                                                                                                    
                                                                                                    if (*bit-*ait==1)                                      
                                                                                                        // some pitches in the superset belong to more than one harmonic series and can have more than one harmonic weight, in which case we choose the stronger weight
                                                                                                        for (int i=1; i<(noct+1); i++)
                                                                                                        {
                                                                                                            if (*ait==oa[i]%12) {hn1=1; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+12) {hn1=2; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+19) {hn1=3; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+24) {hn1=4; oct1=oa[i]/12;}
                                                                                                            /*
                                                                                                            if (*ait==oa[i]%12+28) {hn1=5; oct1=oa[i]/12;}                                
                                                                                                            if (*ait==oa[i]%12+31) {hn1=6; oct1=oa[i]/12;}                                
                                                                                                            if (*ait==oa[i]%12+34) {hn1=7; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+36) {hn1=8; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+38) {hn1=9; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+40) {hn1=10; oct1=oa[i]/12;}
                                                                                                            */
                                                                                                            
                                                                                                            if (*bit==oa[i]%12) {hn2=1; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+12) {hn2=2; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+19) {hn2=3; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+24) {hn2=4; oct2=oa[i]/12;}
                                                                                                            /*
                                                                                                            if (*bit==oa[i]%12+28) {hn2=5; oct2=oa[i]/12;}                                
                                                                                                            if (*bit==oa[i]%12+31) {hn2=6; oct2=oa[i]/12;}                                
                                                                                                            if (*bit==oa[i]%12+34) {hn2=7; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+36) {hn2=8; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+38) {hn2=9; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+40) {hn2=10; oct2=oa[i]/12;}   
                                                                                                            */                                
                                                                                                        }
                                                                                                    
                                                                                                    // Calculating the total roughness due to the minor seconds
                                                                                                    m2=m2+pow(0.60,oct1-4)*hw[hn1]*pow(0.60,oct2-4)*hw[hn2];
                                                                                                    
                                                                                                    hn1=0;
                                                                                                    hn2=0;                          
                                                                                                }                        
                                                                                                                        
                                                                                                // Creating a collection of chords and their properties                                                                                                
                                                                                                coll[1][c]=m2;
                                                                                                coll[2][c]=pcs012;
                                                                                                coll[3][c]=pcs014;
                                                                                                coll[4][c]=pcs016;
                                                                                                coll[5][c]=pcs036;
                                                                                                coll[6][c]=ic13;                        
                                                                                                
                                                                                                
                                                                                                
                                                                                                // Resetting the values of some of the parameters before moving on to the next chord
                                                                                                m2=0;
                                                                                                aset.clear();
                                                                                                hn1=0;
                                                                                                hn2=0;
                                                                                                pcs012=0;
                                                                                                pcs014=0;
                                                                                                pcs016=0;
                                                                                                pcs036=0;
                                                                                                ic13=0;    
                                                                                                
                                                                                                noct--;                  
                                                                                                
                                                                                                
                                                                                            } 
                                                                                            if (noct<12) break; 
                                                                                        }                               
                                                                                    }   
                                                                                    if (noct<11) break;
                                                                                }                 
                                                                            } 
                                                                            if (noct<10) break;   
                                                                        }        
                                                                    } 
                                                                    if (noct<9) break;    
                                                                }                                                                                               
                                                            }  
                                                            if (noct<8) break;   
                                                        }                            
                                                    }  
                                                    if (noct<7) break;   
                                                }               
                                            } 
                                            if (noct<6) break;   
                                        }        
                                    }  
                                    if (noct<5) break;  
                                }                                                                                                                            
                            }  
                            if (noct<4) break;   
                        }                            
                    } 
                    if (noct<3) break;    
                }               
            }
            if (noct<2) break;   
        }           
    }
    
    int size=c;
    
    for(int j=1;j<23;j++) row[j]=0;
    array.push_back(row);
    for(int i=1;i<(c+1);i++)
    {
        for(int j=1;j<23;j++) row[j]=coll[j][i];
        
        array.push_back(row);  
    }
    
    sort(array.begin(), array.end(), Compare);
    
    for(int i=1; i<(c+1); i++)
    {
        for(int j=1;j<23;j++) coll[j][i]=array[i][j];
    }
    
    // Printing the sorted chord collection into a file
    ofstream myfile;
    myfile.open ("chordcollection.txt");

    int t1, t2;
    t1=1;
    t2=1;
  
    noct=noct+1;
    
    for (int c=1; c<size+1; c++)
    {              
        oa[1]=coll[11][c];
        oa[2]=coll[12][c];
        oa[3]=coll[13][c];
        oa[4]=coll[14][c];
        oa[5]=coll[15][c]; 
        oa[6]=coll[16][c]; 
        oa[7]=coll[17][c]; 
        oa[8]=coll[18][c]; 
        oa[9]=coll[19][c]; 
        oa[10]=coll[20][c]; 
        oa[11]=coll[21][c]; 
        oa[12]=coll[22][c];
        
        if ((coll[3][c]+coll[4][c])<(coll[3][c-1]+coll[4][c-1])) myfile<<endl;
                   
        if (((coll[3][c]+coll[4][c])!=0) && (t1==1)) 
        {
            t1=0;
            myfile<<endl<<endl<<"pcs(014) or pcs(016)"<<endl;
        }
               
        if (coll[5][c]<coll[5][c-1]) myfile<<endl;
               
        if ((coll[2][c]!=0) && (t2==1))
        {
            t2=0;
            myfile<<endl<<"pcs(012)"<<endl;
        }     
            
        myfile<<endl<<c<<") ";                        
           
        for (int i=1; i<(noct+1); i++)
        {           
            if ((oa[i]%12)==0) myfile<<"C";
            if ((oa[i]%12)==1) myfile<<"Db";
            if ((oa[i]%12)==2) myfile<<"D";
            if ((oa[i]%12)==3) myfile<<"Eb";
            if ((oa[i]%12)==4) myfile<<"E";
            if ((oa[i]%12)==5) myfile<<"F";
            if ((oa[i]%12)==6) myfile<<"F#";
            if ((oa[i]%12)==7) myfile<<"G";
            if ((oa[i]%12)==8) myfile<<"Ab";
            if ((oa[i]%12)==9) myfile<<"A";
            if ((oa[i]%12)==10) myfile<<"Bb";
            if ((oa[i]%12)==11) myfile<<"B";            
             
            if ((oa[i]/12)==1) myfile<<"1, ";
            if ((oa[i]/12)==2) myfile<<"2, ";
            if ((oa[i]/12)==3) myfile<<"3, ";
            if ((oa[i]/12)==4) myfile<<"4, ";
            if ((oa[i]/12)==5) myfile<<"5, ";
            if ((oa[i]/12)==6) myfile<<"6, ";
            if ((oa[i]/12)==7) myfile<<"7, ";
            
            if ((oa[i]/12)==0) myfile<<"err, "<<oa[i]<<" ";
        } 
                        
        myfile<<"m2s="<<coll[1][c]<<", ic13="<<coll[6][c]<<", pcs036="<<coll[5][c]<<", pcs014="<<coll[3][c]<<", pcs016="<<coll[4][c]<<", pcs012="<<coll[2][c];
                
    }      
    
    myfile.close();
 

    myfile.open (textfilename.c_str());
  
    for (int c=1; c<size+1; c++)
    {               
        oa[1]=coll[11][c];
        oa[2]=coll[12][c];
        oa[3]=coll[13][c];
        oa[4]=coll[14][c];
        oa[5]=coll[15][c]; 
        oa[6]=coll[16][c]; 
        oa[7]=coll[17][c]; 
        oa[8]=coll[18][c]; 
        oa[9]=coll[19][c]; 
        oa[10]=coll[20][c]; 
        oa[11]=coll[21][c]; 
        oa[12]=coll[22][c];
        
        myfile<<c<<" ";
        myfile<<round(c*100/size)<<" ";
        
        for (int i=1; i<(noct+1); i++)
        {   
            myfile<<oa[i]<<" ";            
        }   
        
        myfile<<endl;                                    
        
    }
    
    myfile.close();    
  
    for (int i=0; i<23; i++)
    {
        delete [] coll[i];
    }
    
    delete [] coll;

return 0;
}  

int main()
{
    int pitch, nct, sp, bs, mml;

    vector< vector<int> > prog;
    vector<int> fc, pc, ctemp;
    
    bool added=false;
    srand((unsigned)time(NULL));

    // Algorithm:
    // Reading the soprano and bass voices from text files
    // Inputting the first chord
    // Getting the next pair of soprano and bass tones and creating the next new chord
        // internal voices move in random small-interval motion to create a new chord
        // no pitch can be repeated within the chord
        // interval between two adjacent voices can not exceed a major seventh
        // voices should not cross each other
        // the new chord should not have the same structure as of any of the previous chords of the progression
    // Using the chord analyzer module to create a list of all the chords of the same span and number of chord-tones sorted according to their level of tension
    // Searching for the new chord in the list to make sure that it is in a specific range of tension. Tension-wise, each chord should be within a specific distance to its preceding chord. 
    // Repeating the process for every pair of soprano and bass tones
    
    cout<<endl<<"How many chord tones are there in each chord: ";
    cin>>nct;
    
    cout<<endl<<"How large would you like maximum melodic leap in the internal voices to be: ";
    cin>>mml;    
    
    // Inputting the first chord
    cout<<endl<<"Enter the first chord in midi numbers. Start with the bass tone and press enter after each entry. The soprano and bass tones of this chord should match with the first pair of tones from the soprano and bass files:"<<endl; 
    for (int i=0; i<nct; i++) 
    {
        cin>>pitch; fc.push_back(pitch); cout<<endl;
    }
       
    // Reading the soprano and bass voices from text files
    ifstream input1("soprano.txt");
    vector< vector<int> > soprano;
    vector<int> sptemp;
    string t;
    while (getline(input1,t)) 
    {
        istringstream in (t, istringstream::in);
        copy(istream_iterator<int>(in), istream_iterator<int>(), back_inserter(sptemp));
        soprano.push_back(sptemp);
    }
    
    ifstream input2("bass.txt");
    vector< vector<int> > bass;
    vector<int> bstemp;
    while (getline(input2,t)) 
    {
        istringstream in (t, istringstream::in);
        copy(istream_iterator<int>(in), istream_iterator<int>(), back_inserter(bstemp));
        bass.push_back(bstemp);
    }
        
    // Inserting the first chord into the progression
    prog.push_back(fc);
    
    for (int i=0; i<fc.size(); i++)
        pc.push_back(fc[i]);
        
    bool norepeatedpitch, goodvoicing, novoicecrossing;
    
    int count[100]={0};
    
    int ipstatus[100]={0};
    
    int e[100]={0};
    int nincoll[100]={0};
         
    // Getting the next pair of soprano and bass tones and creating the next chord by moving the internal voices of the previous chord in random small-interval motion
    for (int ip=1; ip<soprano[0].size(); ip++)
    {            
        sp=soprano[0][ip];
        bs=bass[0][ip];
        
        int cs=soprano[0][ip]-bass[0][ip];
        
        if (ipstatus[ip]==0) chordcollection(nct,cs,bs,ip);
        
        ipstatus[ip]=1;
        
        std::string textfile ("collection");
        string cnumber;
        ostringstream converter;
        converter << ip;
        cnumber = converter.str();
        textfile += cnumber;
        textfile += ".txt";

        ifstream input3(textfile.c_str());
        vector< vector<int> > collection;
        vector<int> colltemp;
        collection.clear();
        while (getline(input3,t)) 
        {
            istringstream in (t, istringstream::in);
            copy(istream_iterator<int>(in), istream_iterator<int>(), back_inserter(colltemp));
            collection.push_back(colltemp); colltemp.clear();
        }
        
        added=false;
                
        while (added==false)
        {                          
            norepeatedpitch=false;
            goodvoicing=false;   
            novoicecrossing=false;
        
            while ((count[ip]<10000) && ((norepeatedpitch==false) || (goodvoicing==false) || (novoicecrossing==false)))
            {  
                ctemp.clear();
                ctemp.push_back(bs);
                count[ip]++;
                
                // Internal voices of the last chord move in random small-interval motion to create a new chord, 'ctemp'            
                for (int i=1; i<pc.size()-1; i++)
                    ctemp.push_back(pc[i]+(rand()%(mml*2+1))-mml);
                    
                ctemp.push_back(sp); 
                
                norepeatedpitch=true;
                goodvoicing=true;   
                novoicecrossing=true;     
                     
                // No pitch can be repeated within the new chord
                for (int i=0; i<ctemp.size(); i++)
                    for (int j=0; j<ctemp.size(); j++)
                        if ((i!=j) && (ctemp[i]%12==ctemp[j]%12)) norepeatedpitch=false;
                
                // The interval between two adjacent voices can not exceed a major seventh
                for (int i=0; i<ctemp.size()-1; i++)
                    if (ctemp[i+1]-ctemp[i]>11) goodvoicing=false;
                
                // Voices should not cross each other  
                for (int i=0; i<ctemp.size()-1; i++)
                    if (ctemp[i+1]<ctemp[i]) novoicecrossing=false;
            }    
            
            // sort(ctemp.begin(), ctemp.end());               
            
            // Checking to make sure that the next soprano and bass tones are not present in this chord
            int fl=1;
            
            for (int ii=0; ii<ctemp.size(); ii++)
            {
                if (ctemp[ii]==soprano[0][ip+1]) fl=0;
                if (ctemp[ii]==bass[0][ip+1]) fl=0;                    
            }
            
            // Trying to have variety            
            // Checking to see if this new chord has been used before
            int fflag=1;
            
            for (int iprog=0; iprog<prog.size(); iprog++)
            {
                int cnst=prog[iprog][0]-ctemp[0]; int flag=0;
                for (int jprog=0; jprog<prog[iprog].size(); jprog++)
                {
                    if ((prog[iprog][jprog]-ctemp[jprog])!=cnst) flag=1;
                }
                if (flag==0) fflag=0;
            }
            
            bool same=true;
            e[ip]=101;

            // Searching for the new chord in the sorted list of all chords of the same chord-span and number of chord-tones to make sure that it is in a specific range of tension.
            for (int i=0; i<collection.size(); i++)
            {    
                same=true;
                for (int j=1; j<nct+1; j++)
                    if (ctemp[j-1]-bs+48!=collection[i][j+1]) same=false;
                    
                if (same==true) {e[ip]=collection[i][1]; nincoll[ip]=collection[i][0];}
            }
            
            bool goodloe=false;          
            
            if ((ip>1) && (e[ip]>5) && (e[ip]<15) && (abs(e[ip]-e[ip-1])<5)) goodloe=true;
            
            if ((ip==1) && (e[ip]>5) && (e[ip]<15)) goodloe=true;
            
            // Moving back a step in the chord progression if 10000 new chords have been tried without any success 
            bool br=false;            
            
            if (ip>2)
            {   
                br=false;
                if (count[ip]==10000)
                   {
                       prog.pop_back(); 
                       count[ip-1]++; 
                       count[ip]=0;
                       added=true; 
                       pc.clear(); 
                       for (int i=0; i<prog[ip-2].size(); i++) 
                           pc.push_back(prog[ip-2][i]); 
                       
                       ip=ip-2;
                        
                       br=true;   
                   }                  
            }
            
            if (br==true) break;

            // accepting or rejecting the new chord
            if ((count[ip]<10000) && (fflag==1) && (fl==1) && (goodloe==true))
            {                
                prog.push_back(ctemp); added=true; pc.clear(); for (int i=0; i<ctemp.size(); i++) pc.push_back(ctemp[i]);
            }
        }
        ctemp.clear();
        if (added==false) prog.push_back(ctemp);
    }
    
    for (int i=0; i<prog.size(); i++)
    {
        for (int j=0; j<prog[i].size(); j++)
        cout<<prog[i][j]<<" "; cout<<" level of harmonic tension = "<<e[i]<<" chord number in collection = "<<nincoll[i]<<endl;
    }
    
    cout<<endl;
  
    // Writing the progression into a midi file readable to human
    ofstream myfile;
    
    myfile.open ("chordprogression.txt");
  
    int time=0;
  
    myfile<<"MFile 1 2 1024"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 SMPTE 0 0 0 0 0"<<endl;
    myfile<<"0 TimeSig 1/4 24 8"<<endl;
    myfile<<"0 KeySig 0 major"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
    myfile<<"0 Meta TrkName "<<"'Piano'"<<endl;  

    for (int i=0; i<prog.size(); i++)
    {    
        for (int j=0; j<prog[i].size(); j++)
        {   
            myfile<<time<<" on"<<" ch=1"<<" n="<<prog[i][j]<<" v=72"<<endl;            
        }                                       
               
        time=time+956;
        
        for (int j=0; j<prog[i].size(); j++)
        {   
            myfile<<time<<" off"<<" ch=1"<<" n="<<prog[i][j]<<" v=72"<<endl;            
        } 
        
        time=time+68;        
    }
        
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd";
    
    myfile.close();    

return 0;
}  

